ANALYZER_PREFIX = "/analyzer"
CHEMISTRY_PREFIX = "/chemistry"
EXECUTE_PREFIX = "/execute"
COMBINATORIAL_OPTIMIZATION_PREFIX = "/combinatorial_optimization"
QSVM_PREFIX = "/qsvm"
ANALYZER_CIRCUIT_PAGE = "circuit"
DEFAULT_IDE_FE_APP = "https://platform.classiq.io/"

ANALYZER_QC_GRAPH = "/graphs/qubits_connectivity"
ANALYZER_QC_GRAPH_FULL_PATH = ANALYZER_PREFIX + ANALYZER_QC_GRAPH

ANALYZER_HC_GRAPH = "/graphs/hardware_connectivity"
ANALYZER_HC_GRAPH_FULL_PATH = ANALYZER_PREFIX + ANALYZER_HC_GRAPH

ANALYZER_HEATMAP_GRAPH = "/graphs/heatmap"
ANALYZER_HEATMAP_GRAPH_FULL_PATH = ANALYZER_PREFIX + ANALYZER_HEATMAP_GRAPH

ANALYZER_GATE_HISTO_GRAPH = "/graphs/gate_histo"
ANALYZER_GATE_HISTO_GRAPH_FULL_PATH = ANALYZER_PREFIX + ANALYZER_GATE_HISTO_GRAPH

ANALYZER_HC_TABLE_GRAPH = "/graphs/hardware_comparison_table"
ANALYZER_HC_TABLE_GRAPH_FULL_PATH = ANALYZER_PREFIX + ANALYZER_HC_TABLE_GRAPH

ANALYZER_HC_GRAPH_NEW = "/graphs/hardware_connectivity/new"

ANALYZER_OPTIONAL_DEVICES = "/graphs/available_devices"
ANALYZER_OPTIONAL_DEVICES_FULL_PATH = ANALYZER_PREFIX + ANALYZER_OPTIONAL_DEVICES

TASKS_SUFFIX = "/tasks"
QUANTUM_PROGRAM_SUFFIX = "/quantum_program"
SUBMIT_SUFFIX = "/submit"
STATUS_SUFFIX = "/status"
CANCEL_SUFFIX = "/cancel"
RESULT_SUFFIX = "/result"
AMPLITUDE_ESTIMATION_SUFFIX = "/amplitude_estimation"
AMPLITUDE_ESTIMATION_WITH_QPE_SUFFIX = "/amplitude_estimation_with_qpe"
GROVER_SUFFIX = "/grover"
FINANCE_SUFFIX = "/finance"
VQE_SUFFIX = "/vqe"
ESTIMATE_SUFFIX = "/estimate"
RB = "/rb"
ANALYZER_DATA_TASK = f"{TASKS_SUFFIX}/data"
ANALYZER_QASM_TASK = f"{TASKS_SUFFIX}/qasm"

ANALYZER_DATA_TASK_UPLOAD_FILE = f"{TASKS_SUFFIX}/data/file_upload"
ANALYZER_DATA_FULL_PATH = f"{ANALYZER_PREFIX}{ANALYZER_DATA_TASK}"
ANALYZER_QASM_FULL_PATH = f"{ANALYZER_PREFIX}{ANALYZER_QASM_TASK}"

IDE_QASM_TASK = f"{TASKS_SUFFIX}/generated_circuit_from_qasm"
IDE_QASM_FULL_PATH = f"{ANALYZER_PREFIX}{IDE_QASM_TASK}"
IDE_EXECUTION_RESULTS_PATH = f"/results{EXECUTE_PREFIX}"
ASYNC_TASKS_SUFFIX = "/async_tasks"
TASKS_GENERATE_SUFFIX = TASKS_SUFFIX + "/generate"
TASKS_GAS_SUFFIX = "/tasks/gas"
TASKS_SOLVE_SUFFIX = "/tasks/solve"
TASKS_SOLVE_GAS_ASYNC_SUFFIX = "/tasks/solve_gas_async"
TASKS_SOLVE_VQE_ASYNC_SUFFIX = "/tasks/solve_vqe_async"
DEVICES_INFORMATION = "/devices_inform"
AWS_TASKS_COST = "/aws/tagged-tasks"

TASKS_SOLVE_CLASSICALLY_SUFFIX = "/tasks/solve_classically"
TASKS_MODEL_SUFFIX = "/tasks/model"
TASKS_OPERATOR_SUFFIX = "/tasks/operator"
TASKS_OBJECTIVE_SUFFIX = "/tasks/objective"
TASKS_INITIAL_POINT_SUFFIX = "/tasks/initial_point"
TASK_TRAIN_SUFFIX = TASKS_SUFFIX + "/train"
TASK_TEST_SUFFIX = TASKS_SUFFIX + "/test"
TASK_PREDICT_SUFFIX = TASKS_SUFFIX + "/predict"
TASK_RB_SUFFIX = TASKS_SUFFIX + RB
TASKS_GENERATE_FULL_PATH = TASKS_GENERATE_SUFFIX
TASKS_SOLVE_EXACT_SUFFIX = "/tasks/solve_exact"
TASKS_UCC_OPERATORS_SUFFIX = "/tasks/ucc_operators"

TASKS_GET_MAX_CUT_MODEL = "/tasks/get_max_cut_model"

EXECUTE_QUANTUM_PROGRAM_FULL_PATH = EXECUTE_PREFIX + QUANTUM_PROGRAM_SUFFIX
EXECUTE_QUANTUM_PROGRAM_PREFIX = EXECUTE_QUANTUM_PROGRAM_FULL_PATH
EXECUTE_QUANTUM_PROGRAM_SUBMIT_FULL_PATH = (
    EXECUTE_QUANTUM_PROGRAM_PREFIX + SUBMIT_SUFFIX
)
EXECUTE_AMPLITUDE_ESTIMATION_FULL_PATH = EXECUTE_PREFIX + AMPLITUDE_ESTIMATION_SUFFIX
EXECUTE_AMPLITUDE_ESTIMATION_WITH_QPE_FULL_PATH = (
    EXECUTE_PREFIX + AMPLITUDE_ESTIMATION_WITH_QPE_SUFFIX
)
EXECUTE_GROVER_FULL_PATH = EXECUTE_PREFIX + GROVER_SUFFIX
EXECUTE_FINANCE_FULL_PATH = EXECUTE_PREFIX + FINANCE_SUFFIX
EXECUTE_ESTIMATE_FULL_PATH = EXECUTE_PREFIX + ESTIMATE_SUFFIX
EXECUTE_VQE_FULL_PATH = EXECUTE_PREFIX + VQE_SUFFIX
EXECUTE_ASYNC_TASKS_FULL_PATH = EXECUTE_PREFIX + ASYNC_TASKS_SUFFIX

EXECUTE_DEVICES_INFORMATION_FULL_PATH = ANALYZER_PREFIX + DEVICES_INFORMATION
ANALYZER_FULL_PATH = ANALYZER_PREFIX + TASKS_SUFFIX
ANALYZER_RB_FULL_PATH = ANALYZER_PREFIX + TASK_RB_SUFFIX

COMBINATORIAL_OPTIMIZATION_GAS_CIRCUIT_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_GAS_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_SOLVE_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_SOLVE_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_SOLVE_GAS_ASYNC_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_SOLVE_GAS_ASYNC_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_SOLVE_VQE_ASYNC_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_SOLVE_VQE_ASYNC_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_SOLVE_CLASSICALLY_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_SOLVE_CLASSICALLY_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_MODEL_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_MODEL_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_OPERATOR_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_OPERATOR_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_OBJECTIVE_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_OBJECTIVE_SUFFIX
)
COMBINATORIAL_OPTIMIZATION_INITIAL_POINT_FULL_PATH = (
    COMBINATORIAL_OPTIMIZATION_PREFIX + TASKS_INITIAL_POINT_SUFFIX
)

CHEMISTRY_GENERATE_HAMILTONIAN_FULL_PATH = CHEMISTRY_PREFIX + TASKS_SUFFIX
CHEMISTRY_GENERATE_UCC_OPERATORS_FULL_PATH = (
    CHEMISTRY_PREFIX + TASKS_UCC_OPERATORS_SUFFIX
)
CHEMISTRY_SOLVE_EXACT_FULL_PATH = CHEMISTRY_PREFIX + TASKS_SOLVE_EXACT_SUFFIX
CHEMISTRY_SOLVE_FULL_PATH = CHEMISTRY_PREFIX + TASKS_SOLVE_SUFFIX

QSVM_TRAIN = QSVM_PREFIX + TASK_TRAIN_SUFFIX
QSVM_TEST = QSVM_PREFIX + TASK_TEST_SUFFIX
QSVM_PREDICT = QSVM_PREFIX + TASK_PREDICT_SUFFIX

AWS_TASKS_COST_FULL_PATH = EXECUTE_ASYNC_TASKS_FULL_PATH + AWS_TASKS_COST
